import c4d
from c4d import gui
import re
import math
#Welcome to the world of Python

def FromMlToMg(mother, child_lokal_pos, child_lokal_rot):
    if isinstance(mother, c4d.BaseObject): mg = mother.GetMg()
    if isinstance(mother, c4d.Matrix): mg = mother
    if child_lokal_rot != None:
        if child_lokal_rot == "mother": rot = c4d.Matrix()
        else: 
            if isinstance(child_lokal_rot, c4d.Vector): rot = c4d.utils.HPBToMatrix(child_lokal_rot)
            if isinstance(child_lokal_rot, c4d.Matrix): rot = child_lokal_rot
            if isinstance(child_lokal_rot, c4d.BaseObject): rot = child_lokal_rot.GetMg()
    if child_lokal_pos != None:
        if child_lokal_pos == "mother": pos = c4d.Vector(0,0,0)
        else: 
            if isinstance(child_lokal_pos, c4d.Vector): pos = child_lokal_pos
            if isinstance(child_lokal_pos, c4d.Matrix): pos = child_lokal_pos.off
            if isinstance(child_lokal_pos, c4d.BaseObject): pos = child_lokal_pos.GetMg().off
    if child_lokal_rot == None and child_lokal_pos != None: 
        return c4d.Matrix(mg.Mul(pos),c4d.Vector(1,0,0),c4d.Vector(0,1,0),c4d.Vector(0,0,1))
    elif child_lokal_rot != None and child_lokal_pos == None: 
        new_mg = c4d.Matrix.__mul__(mg,c4d.Matrix(c4d.Vector(0,0,0), rot.v1, rot.v2, rot.v3))
        new_mg.off = c4d.Vector(0,0,0)
        return new_mg
    elif child_lokal_rot == None and child_lokal_pos == None: return c4d.Matrix()
    else: return c4d.Matrix.__mul__(mg,c4d.Matrix(pos, rot.v1, rot.v2, rot.v3))

def FromMgToMl(mother, child_global_pos, child_global_rot):
    if isinstance(mother, c4d.BaseObject): mg = mother.GetMg()
    if isinstance(mother, c4d.Matrix): mg = mother
    if child_global_rot != "mother":
        if child_global_rot == None: rot = c4d.Matrix()
        else: 
            if isinstance(child_global_rot, c4d.Vector): rot = c4d.utils.HPBToMatrix(child_global_rot)
            if isinstance(child_global_rot, c4d.Matrix): rot = child_global_rot
            if isinstance(child_global_rot, c4d.BaseObject): rot = child_global_rot.GetMg()
    if child_global_pos != "mother":
        if child_global_pos == None: pos = c4d.Vector(0,0,0)
        else: 
            if isinstance(child_global_pos, c4d.Vector): pos = child_global_pos
            if isinstance(child_global_pos, c4d.Matrix): pos = child_global_pos.off
            if isinstance(child_global_pos, c4d.BaseObject): pos = child_global_pos.GetMg().off
    if child_global_rot == "mother" and child_global_pos != "mother": 
        return c4d.Matrix(mg.__invert__().Mul(pos),c4d.Vector(1,0,0),c4d.Vector(0,1,0),c4d.Vector(0,0,1))
    elif child_global_rot != "mother" and child_global_pos == "mother": 
        new_mg = c4d.Matrix.__mul__(mg.__invert__(),c4d.Matrix(c4d.Vector(0,0,0), rot.v1, rot.v2, rot.v3))
        new_mg.off = c4d.Vector(0,0,0)
        return new_mg
    elif child_global_rot == "mother" and child_global_pos == "mother": return c4d.Matrix()
    else: return c4d.Matrix.__mul__(mg.__invert__(),c4d.Matrix(pos, rot.v1, rot.v2, rot.v3))

def GetDistance(vec1, vec2):
    dist = vec1 - vec2
    return math.sqrt(dist.x**2 + dist.y**2 + dist.z**2)

def AimAxis(pos, aim_pos, aim_axis, up_pos, up_axis):
    axis = (aim_axis, up_axis)
    axis_pos = (aim_pos, up_pos)
    new_Ml = c4d.Matrix()
    new_Ml.off = pos

    for i in axis:
        if re.search(r"\A[-+]{,1}[xyz]\Z", i) == None: 
            print "String '{0}' wird nicht verstanden".format(i)
            return None
        if re.search(r"\A-[xyz]\Z", i) != None:
            if i == axis[0]: aim_vec = -(aim_pos - pos)
            if i == axis[1]: up_vec = -(pos - up_pos)
        else:
            if i == axis[0]: aim_vec = aim_pos - pos
            if i == axis[1]: up_vec = pos - up_pos

    aim_vec_norm = aim_vec.GetNormalized()
    third_vec_norm = aim_vec.Cross(up_vec).GetNormalized()
    up_vec_norm = aim_vec.Cross(third_vec_norm).GetNormalized()

    for i in axis:
        if i == axis[0]:
            if re.search(r"\A[-+]{,1}[x]\Z",i) != None: new_Ml.v1 = aim_vec_norm
            if re.search(r"\A[-+]{,1}[y]\Z",i) != None: new_Ml.v2 = aim_vec_norm
            if re.search(r"\A[-+]{,1}[z]\Z",i) != None: new_Ml.v3 = aim_vec_norm
        if i == axis[1]:
            if re.search(r"\A[-+]{,1}[x]\Z",i) != None: new_Ml.v1 = up_vec_norm
            if re.search(r"\A[-+]{,1}[y]\Z",i) != None: new_Ml.v2 = up_vec_norm
            if re.search(r"\A[-+]{,1}[z]\Z",i) != None: new_Ml.v3 = up_vec_norm

    new_str = ""
    for i in range(len(str(axis))):
        if re.search(r"[xyz]", str(axis)[i]) != None: new_str = new_str + str(axis)[i]
    
    if new_str[0] == new_str[1]:
        gui.MessageDialog("Benutze zwei unterschiedliche Achsen!") 
        return None    

    if new_str in ["zy","xz","yx"]:
        if re.search(r"\A[^x]{1,2}\Z", new_str) != None: new_Ml.v1 = third_vec_norm
        if re.search(r"\A[^y]{1,2}\Z", new_str) != None: new_Ml.v2 = third_vec_norm
        if re.search(r"\A[^z]{1,2}\Z", new_str) != None: new_Ml.v3 = third_vec_norm
    else:
        if re.search(r"\A[^x]{1,2}\Z", new_str) != None: new_Ml.v1 = -third_vec_norm
        if re.search(r"\A[^y]{1,2}\Z", new_str) != None: new_Ml.v2 = -third_vec_norm
        if re.search(r"\A[^z]{1,2}\Z", new_str) != None: new_Ml.v3 = -third_vec_norm

    return new_Ml

def Pos2Off(obj, local_pos):
    if isinstance(obj, c4d.BaseObject): mg = obj.GetMg()
    if isinstance(obj, c4d.Matrix): mg = obj
    if isinstance(local_pos, c4d.Vector): pos = local_pos
    if isinstance(local_pos, c4d.Matrix): pos = local_pos.off
    if isinstance(local_pos, c4d.BaseObject): pos = local_pos.GetMg().off
    pos = c4d.Vector(pos.x,pos.y,pos.z)
    return mg.Mul(pos)

def Off2Pos(obj, global_pos):
    if isinstance(obj, c4d.BaseObject): mg = obj.GetMg()
    if isinstance(obj, c4d.Matrix): mg = obj
    if isinstance(global_pos, c4d.Vector): pos = global_pos
    if isinstance(global_pos, c4d.Matrix): pos = global_pos.off
    if isinstance(global_pos, c4d.BaseObject): pos = global_pos.GetMg().off
    return mg.__invert__().Mul(pos)

def Abs2Frozen(obj):
    obj.SetFrozenPos(obj.GetAbsPos())
    obj.SetFrozenRot(obj.GetAbsRot())
    obj.SetRelPos(c4d.Vector(0,0,0))
    obj.SetRelRot(c4d.Vector(0,0,0))

def GetGlPointsTuple(obj):
    points = obj.GetAllPoints()
    gl_points = ()
    for i in points: gl_points = gl_points + (Pos2Off(obj, i),)
    return gl_points

class Dlg(gui.GeDialog):
    
    GROUP = 1000
    TOLGROUP = 1001
    TOLTEXT = 1002
    TOLREAL = 1003
    UPTEXT = 1004
    UPCOMBO = 1005
    UPZ = 1006
    UPmZ = 1007
    CGROUP = 1008
    OK = 1009
    CANCEL = 1010

    tol_real = 5
    up_str = "z"

    def CreateLayout(self):
        self.GroupBegin(self.TOLGROUP, c4d.BFV_SCALE, cols=2)
        self.AddStaticText(self.TOLTEXT, c4d.BFH_LEFT, name="   Toleranz")
        self.AddEditNumber(self.TOLREAL, c4d.BFH_SCALEFIT, initw=40)
        self.AddStaticText(self.UPTEXT, c4d.BFH_LEFT, name="   UpVector")
        self.AddComboBox(self.UPCOMBO, c4d.BFH_SCALEFIT, initw=20)     
        self.AddChild(self.UPCOMBO, self.UPZ, "z")  
        self.AddChild(self.UPCOMBO, self.UPmZ, "-z")  
        self.AddButton(self.OK, c4d.BFH_SCALEFIT, name="OK")
        self.AddButton(self.CANCEL, c4d.BFH_SCALE, name="Abbruch")
        self.GroupEnd()
        return True

    def InitValues(self):
        self.SetMeter(self.TOLREAL, self.tol_real)
        self.SetLong(self.UPCOMBO, self.UPZ)

        return True 

    def Command(self, id, msg):
        if id==self.CANCEL:   
            self.Close()

        if id==self.TOLREAL:
            self.tol_real = self.GetReal(self.TOLREAL)

        if id==self.UPCOMBO:
            if self.GetLong(self.UPCOMBO) == self.UPZ: self.up_str = "z"
            if self.GetLong(self.UPCOMBO) == self.UPmZ: self.up_str = "-z"

        if id==self.OK: 
            Align(self.tol_real, self.up_str)
            self.Close()
    
        return True 

def Align(tol_real, up_str):
    c4d.StopAllThreads()
    root = doc.GetActiveObject()
    child = root
    obj_tup = ()
    mat_tup = ()
    pnts_tup = ()
    while child != None:
        if child == root:
            mpnts = GetGlPointsTuple(child)
            if child.GetDown() == None: cpnts = GetGlPointsTuple(child.GetUp())
            else: cpnts = GetGlPointsTuple(child.GetDown())
        else:
            mpnts = GetGlPointsTuple(child)
            if child.GetUp() == None: cpnts = GetGlPointsTuple(child.GetDown())
            else: cpnts = GetGlPointsTuple(child.GetUp())
        mutpnts = ()
        ownpnts = ()
        for cpoint in cpnts:
            for mpoint in mpnts:
                if GetDistance(cpoint, mpoint) < tol_real:
                    mutpnts = mutpnts + (mpoint,)
        for mpoint in mpnts:
            if mpoint not in mutpnts: ownpnts = ownpnts + (mpoint,)
        if len(mutpnts) != 2: 
            return False
        
        if child == root:
            off = (ownpnts[0]+ownpnts[1])/2
            aim = (mutpnts[0]+mutpnts[1])/2
        else:
            off = (mutpnts[0]+mutpnts[1])/2
            aim = (ownpnts[0]+ownpnts[1])/2

        up = FromMgToMl(child, off, child)
        up = Pos2Off(up,c4d.Vector(0,0,50))
        up = FromMlToMg(child, up, child)
        up = up.off
        mat = AimAxis(off, aim, "x", up, up_str)
        if mat == None: return False
        pnts = ()
        for vec in mpnts:
            vec = Off2Pos(mat, vec)
            pnts = pnts + (vec,)
        obj_tup = obj_tup + (child,)                
        mat_tup = mat_tup + (mat,)   
        pnts_tup = pnts_tup + (pnts,)
        
        child = child.GetDown()

    for i in range(len(obj_tup)): 
        obj_tup[i].SetMg(mat_tup[i])
        for ii in range(len(pnts_tup[i])): 
            obj_tup[i].SetPoint(ii, pnts_tup[i][ii])
        obj_tup[i].Message(c4d.MSG_UPDATE) 
        Abs2Frozen(obj_tup[i])
        
def main():
    root = doc.GetActiveObject()
   
    if root == None:
        gui.MessageDialog("W\hle genau ein Root-Polygon-Objekte aus.")
        return False

    child = root
    child_tup = ()
    while child != None:
        if child.GetType() != 5100:
            gui.MessageDialog("Objekt '" + child.GetName() + "' ist kein Polygon-Objekt.")
            return False 
        child_tup = child_tup + (child,)
        child = child.GetDown()    

    dlg = Dlg()
    dlg.Open(c4d.DLG_TYPE_MODAL,  xpos=850, ypos= 150, defaultw=40, defaulth=20)
    c4d.EventAdd()

if __name__=='__main__':
    main()